#include <stdio.h>

#define MAXLEN 100

typedef struct {
   int element[MAXLEN];
   int top;
} stack;

stack init ()
{
   stack S;

   S.top = -1;
   return S;
}

int isEmpty ( stack S )
{
   return (S.top == -1);
}

int isFull ( stack S )
{
   return (S.top == MAXLEN - 1);
}

int top ( stack S )
{
   if (isEmpty(S)) {
      fprintf(stderr, "top: Empty stack\n");
      return '\0';
   }
   return S.element[S.top];
}

stack push ( stack S , int d)
{
   if (isFull(S)) {
      fprintf(stderr, "push: Full stack\n");
      return S;
   }
   ++S.top;
   S.element[S.top] = d;
   return S;
}

stack pop ( stack S )
{
   if (isEmpty(S)) {
      fprintf(stderr, "pop: Empty stack\n");
      return S;
   }
   --S.top;
   return S;
}

void print ( stack S )
{
   int i;

   for (i = S.top; i >= 0; --i) printf("%d",S.element[i]);
}

void rec(int n, stack S)
{
 int tp, res=1;
 int cnt=n;
   printf("Current stack : "); print(S); printf(" with top = %d.\n", top(S));
 while(!isEmpty(S)){
    tp=top(S);
     if(tp==2)
     {
      res=1;
      while(cnt>1)
       {res*=top(S); S=pop(S);cnt--;}
     }
   else{
     S=push(S,n-1);
     n=n-1;
   }
 }
 printf("Factorial = %d\n",res);
 
}


int main ()
{
   stack S;
   int n;
   S = init(); 
   printf("Enter number:");
   scanf("%d",&n);
   S = push(S,n);
   printf("Current stack : "); print(S); printf(" with top = %d.\n", top(S));

 
   rec(n,S);
}

