#include <stdio.h>
#include <stdlib.h>

#define MAX_SIZE 26

void printSubset ( int A[], int m )
/* Print the current subset chosen:
   Print 0 as 'a', 1 as 'b', 2 as 'c', and so on. */
{
   int i;

   printf("{");
   if (m > 0) {
      printf("%c", 'a'+A[0]);
      for (i=1; i<m; ++i) printf(",%c",'a'+A[i]);
   }
   printf("}\n");
}

void subset ( int A[], int n, int m, int k )
/* A stores the choices made so far.
   Subsets of {0,1,2,...,n-1} are printed.
   m is the number of elements chosen in the subset so far.
   k is the last element chosen so far.
   The next choice is allowed to be from k+1,k+2,...,n-1 */
{
   int i; /* i is the next choice */
   printf("n=%d,m=%d,k=%d\n",n,m,k);

   /* Print the subset chosen so far */
   printSubset(A,m);

   /* Choose another element (i), store the choice in the next available
      location of A, and make a recursive call for each choice of i. */
   for (i=k+1; i<n; ++i)
      subset(A,n,m+1,(A[m] = i));
}

int main ()
{
   int A[MAX_SIZE];
   int n;

   printf("Enter n (between 0 and %d): ", MAX_SIZE);
   scanf("%d", &n);
   if ((n < 0) || (n > MAX_SIZE)) exit(1);

   /* First call:
      A is the array for storing the choices.
      n is whatever is supplied by the user.
      No elements are chosen initially (this corresponds to the empty set).
      Last element chosen is -1, so the next element can be from 0 to n-1 */
   subset(A,n,0,-1);

   exit(0);
}
